#ifndef _RTC_																//    
#define _RTC_

#ifdef _RTC_ENABLE_															//  

//===========       - ============
unsigned char bin2bcd(unsigned char n)
{
	return (n/10<<4)+(n % 10);
}

//==========    -    ============
unsigned char bcd2bin(unsigned char n)
{
	return (n>>4)*10+(n & 0x0F);
}

//=========        / ==========
//    :
//RW_bit -    (0-/1-)

void _RTC_Change(char RW_Bit)
{
	TWCR=(1<<TWINT)|(1<<TWSTA)|(1<<TWEN);										//   I2C,   "",   I2C
	while(!(TWCR & (1<<TWINT)));												//  I2C
	
	if (RW_Bit==1) TWDR=0xD0;													// RTC  
	else TWDR=0xD1;																// RTC  
																		
	TWCR=(1<<TWINT)|(1<<TWEN);													// 
	while(!(TWCR & (1<<TWINT)));												//  
}

//===========          =============
void _RTC_Write(char Data)
{
	TWDR=Data;																	//   
	TWCR=(1<<TWINT)|(1<<TWEN);													//  
	while(!(TWCR & (1<<TWINT)));												//  
}

//===========          ============
//    :
//LastByte -     
// :
//   

char _RTC_Read(char LastByte)
{
	if(LastByte) TWCR=(1<<TWINT)|(1<<TWEA)|(1<<TWEN);							// 
	else TWCR=(1<<TWINT)|(1<<TWEN);												
	while(!(TWCR & (1<<TWINT)));												// 
	return TWDR;																// 
}

//===============       =================
void RTC_Init(void)
{
	TWSR=0;																		//   
	TWBR=77;																	//   
	TWAR=0x01;																	//    

	_RTC_Change(1);																//  
	_RTC_Write(0x07);
	_RTC_Write(0x91);
	TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);										// I2C
}

//============================     =============================
void RTC_Get_Time(unsigned char* hour, unsigned char* min, unsigned char* sec)
{
	_RTC_Change(1);																//    
	_RTC_Write(0);
	_RTC_Change(0);
	*sec = bcd2bin(_RTC_Read(1));												// 
	*min = bcd2bin(_RTC_Read(1));												// 
	*hour = bcd2bin(_RTC_Read(0));												// 
	TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);										// I2C
}

//===============================    ================================
void RTC_Set_Time(unsigned char hour, unsigned char min, unsigned char sec)
{
	_RTC_Change(1);																//    
	_RTC_Write(0);
	_RTC_Write(bin2bcd(sec));													// 
	_RTC_Write(bin2bcd(min));													// 
	_RTC_Write(bin2bcd(hour));													// 
	TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);										// I2C
}

//==============================     ===============================
void RTC_Get_Date(unsigned char* date, unsigned char* month, unsigned char* year)
{
	_RTC_Change(1);																//    
	_RTC_Write(4);
	_RTC_Change(0);
	*date = bcd2bin(_RTC_Read(1));												// 
	*month = bcd2bin(_RTC_Read(1));												// 
	*year = bcd2bin(_RTC_Read(0));												// 
	TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);										// I2C
}

//================================    ==================================
void RTC_Set_Date(unsigned char date, unsigned char month, unsigned char year)
{
	_RTC_Change(1);																//    
	_RTC_Write(4);
	_RTC_Write(bin2bcd(date));													// 
	_RTC_Write(bin2bcd(month));													// 
	_RTC_Write(bin2bcd(year));													// 
	TWCR=(1<<TWINT)|(1<<TWSTO)|(1<<TWEN);										// I2C
}

#endif
#endif