
#ifndef _ANALOG_													//    
#define _ANALOG_

#include <avr/iom128.h>												//  /

#define ADC1    1													// "1  "
#define ADC2    2													// "2  "
#define ADC3    3													// "3  "
#define ADC4    4													// "4  "
#define ADC5    5													// "5  "
#define ADC6    6													// "6  "
#define ADC7    7													// "7  "
#define ADC8    8													// "8  "

//==========================     ===========================
//    :
//channel -   ( 1  8)
// :
//0x00-     ,    0xFF

char ADC_Start_Measuring(char channel)
{
	if ((channel<1) || (channel>8)) return 0xFF;					//     ,   
	
	ADMUX=(channel-1) | 0x40;										//       +5
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);	//  ,  ,    128

	return 0;
}

//============================      ==============================
// :
//0xFFFF -     ,      (10 )

int ADC_Read(void)
{
	if ((ADCSRA & (1<<ADIF))!=0) 
	{
		ADCSRA|=(1<<ADIF);											//   
		return	ADC;												//  
	}
	else return 0xFFFF;												//    
}
#endif